unit unPlugin;

interface

type
  TsendInfoStart = function(pluginhost:integer;action,param:pchar):pchar;
  TsendInfoEnd = procedure(memToFree:pchar);

  TPlugin = Class(TObject)
    private

    public
      pluginName : string;
      pluginHost : integer;

    //Server communication
    function sendInfo(action,param : string):string;
    function infoReceived(actionx,param : string):string;
    constructor create(pluginNameX : string; pluginHostx:integer);
    destructor  destroy; override;

    //plugin events
    procedure registerMenuItem(itemName : string);
    procedure unRegisterMenuItem(itemName : string);
    procedure sendEnvelope(envelopeXML : string);
    procedure signalConnected;
    procedure signalNotConnected;
    procedure setInstanceDescr(descr:string);
    procedure addtolog(event:string);    
  end;

var
    sendInfoDllStart : TsendInfoStart;
    sendInfoDllEnd   : TsendInfoEnd;

implementation
uses sysutils,windows,unSupport;

constructor TPlugin.create(pluginNameX : string;pluginHostx:integer);
begin
   //constructor
    pluginName := pluginNameX;
    pluginHost := pluginHostX;

   // opcionlisan lekrhet informcik
   // exedir := ask('getSystemInfo','exedir');
   // engineName := ask('getSystemInfo','engineName');

   registerMenuItem(pluginName+' configuration');
   registerMenuItem(pluginName+' sendsms');
   setInstanceDescr('This is my example plugin');
end;

destructor TPlugin.destroy;
begin
   //destructor
End;


function TPlugin.infoReceived(actionx,param : string):string;
var ret : string;
    param1,param2 : string;
    envelopexml : string;
begin
  ret := '';
  if actionx='autoconnect' then begin
      //A program indtsa utn meghvdik
      //signalConnected;
  end else if actionx='connect' then begin
      //Akkor hvdik meg, ha valaki rkattint
      //a connect linkre.
      signalConnected;    //opcionlisan meghvhat

  end else if actionx='disconnect' then begin
      //Akkor hvdik meg, ha valaki rkattint
      //a disconnect linkre.

      signalNotConnected; //opcionlisan meghvhat

  end else if actionx='uninstall' then begin
      //Akkor hvdik meg, amikor a plugint uninstalljk

  end else if actionx='getForm' then begin
      //Beregisztrlt menpontra trtnt kattints, esetn hvdik meg,
      //a param tartalmazza a menpont nevt, ha vissaad egy XML formot,
      //akkor azt megjelenti a GUI
      //
      // ret := '<Form name="vclform">'+
      //           '<Name>abook_frmSearch</Name>'+
      //           '<Left>450</Left>'+
      //           '<Top>468</Top>'+
      //           '<Height>143</Height>'+
      //           '<Width>439</Width>'+
      //           '<Caption>Example Form</Caption>'+
      //           '<Components>'+
      //                '<TLabel>'+
      //                   '<Name>Label1</Name>'+
      //                   '<Left>16</Left>'+
      //                   '<Top>68</Top>'+
      //                   '<Height>16</Height>'+
      //                   '<Width>46</Width>'+
      //                   '<Caption>Search:</Caption>'+
      //                '</TLabel>'+
      //                '<TButton>'+
      //                    '<Name>bFind</Name>'+
      //                    '<Left>344</Left>'+
      //                      '<Top>64</Top>'+
      //                      '<Height>25</Height>'+
      //                      '<Width>75</Width>'+
      //                      '<Caption>Find</Caption>'+
      //                  '</TButton>'+
      //                  '<TEdit>'+
      //                     '<Name>eSearch</Name>'+
      //                     '<Left>72</Left>'+
      //                     '<Top>64</Top>'+
      //                     '<Height>24</Height>'+
      //                     '<Width>265</Width>'+
      //                     '<Value></Value>'+
      //                     '<Visible>1</Visible>'+
      //                 '</TEdit>'+
      //            '</Components>'+
      //         '</Form>';
      if param = pluginName+' sendsms' then begin
       envelopexml :='<Envelope>'+
                     '<Filename>'+randomstring+'.xml</Filename>'+
                     '<MessageType>SMS:TEXT</MessageType>'+
                     '<Owner>'+pluginName+'</Owner>'+
                     '<Id>'+inttostr(random(100000))+'</Id>'+
                     '<CallbackId></CallbackId>'+
                     '<CreationDate>'+inttostr(unixnow)+'</CreationDate>'+
                     '<Originator>'+'</Originator>'+
                     '<Recepient>+36203105366</Recepient>'+
                     '<Subject>Kimen SMS menu kattintas hatsra</Subject>'+
                     '<RetryCount>6</RetryCount>'+
                     '<History></History>'+
                     '<Status>idle</Status>'+
                     '<Operator>Vodafone1</Operator>'+
                     '<Message>Kimen SMS menu kattintas hatsra</Message>'+
                     '</Envelope>';
          sendEnvelope(envelopexml);
      end;


  end else if actionx='postFormData' then begin
      //a getForm segtsgvel kikldtt form adatai jnnek vissza
      //URLEncoded formtumban visszaadhat egy jabb formot.
      //A param tartalmazza a form nevt s az urlencoded rtkeket
      ret := '';

  end else if actionx='envelope' then begin
      //egy berkezett SMS zenet, a param tartlmazza az XML bortkot.

      //param = '<Envelope>'+
      //        '<Filename>DDJEOADB.xml</Filename>'+
      //        '<MessageType>SMS:TEXT</MessageType>'+
      //        '<Owner>Example plugin 1</Owner>'+
      //        '<Id>6354533</Id>'+
      //        '<CallbackId>6354533</CallbackId>'+
      //        '<CreationDate>1130248925</CreationDate>'+
      //        '<Originator>+36203105366</Originator>'+
      //        '<Recepient>+36303317467</Recepient>'+
      //        '<Subject>proba sms</Subject>'+
      //        '<RetryCount>6</RetryCount>'+
      //        '<History></History>'+
      //        '<Status>idle</Status>'+
      //        '<Operator>Vodafone1</Operator>'+
      //        '<Message>proba sms, hello world</Message>'+
      //        '</Envelope>';

      // azonnali vlasz esetn egy hasonl bortokat kell elkldeni.

      envelopexml := '<Envelope>'+
                     '<Filename>'+randomstring+'.xml</Filename>'+
                     '<MessageType>SMS:TEXT</MessageType>'+
                     '<Owner>'+pluginName+'</Owner>'+
                     '<Id>'+inttostr(random(100000))+'</Id>'+
                     '<CallbackId></CallbackId>'+
                     '<CreationDate>'+inttostr(unixnow)+'</CreationDate>'+
                     '<Originator>'+'</Originator>'+
                     '<Recepient>+36203105366</Recepient>'+
                     '<Subject>valasz SMS</Subject>'+
                     '<RetryCount>6</RetryCount>'+
                     '<History></History>'+
                     '<Status>idle</Status>'+
                     '<Operator>Vodafone1</Operator>'+
                     '<Message>valasz SMS</Message>'+
                     '</Envelope>';

      sendEnvelope(envelopexml);


  end else if actionx='envelopeSent' then begin
      //rtests arrl, hogy a kikldtt SMS-t tvette az SMSC
      //a param az envelope-id-t tartalmazza.

  end else if actionx='envelopeDelivered' then begin
      //rtests arrl, hogy a kikldtt SMS megrkezett a cmzett telefonra
      //a param az envelope-id-t tartalmazza.

  end else if actionx='envelopeDeleted' then begin
      //rtests arrl, hogy a kikldtt SMS-t nem sikerlt kzbesteni.

  end;
  Result := ret;
end;

function TPlugin.sendInfo(action,param : string) : string;
var ret : string;
    pcIn1,pcIn2 : pchar;
    pcOut : pchar;
begin
    try
    ret := '';
    if assigned(sendInfoDllStart) and assigned(sendInfoDllEnd) then begin
      GetMem(pcIn1,length(action)+1); pcIn1 := StrPCopy(pcIn1, action);
      GetMem(pcIn2,length(param)+1); pcIn2 := StrPCopy(pcIn2, param);
      pcOut := sendInfoDllStart(pluginHost,pcIn1,pcIn2);
      if pcOut=nil then ret := '' else begin
         ret := pcOut;
         sendInfoDllEnd(pcOut);
      end;
      FreeMem(pcIn1);
      FreeMem(pcIn2);
    end;
    except
      //you should write a log entry or handle the exception
    end;
    Result := ret;
end;

//**************************************************
//Az ozSMSPhone interface fuggvenyei
//**************************************************

procedure TPlugin.signalConnected;
Begin
    //Ezzel lehet jelezni az engine szmra, hogy
    //a plugin kpes SMS-eket fogadni

    sendInfo('connectionState','online');
End;

procedure TPlugin.signalNotConnected;
Begin
    //Ezzel lehet jelezni az engine szmra, hogy
    //a plugin nem kpes SMS-eket fogadni

    sendInfo('connectionState','offline');
End;

procedure TPlugin.registerMenuItem(itemName : string);
Begin
    //Egy menpont beregisztrlsa

    sendInfo('registerMenuItem',itemName);
End;

procedure TPlugin.unRegisterMenuItem(itemName : string);
Begin
    //Egy beregisztrlsa menpont trlse

    sendInfo('unRegisterMenuItem',itemName);
End;

procedure TPlugin.sendEnvelope(envelopeXML : string);
Begin
    //Egy SMS kldse

    sendInfo('envelope',envelopeXML);
End;

procedure TPlugin.setInstanceDescr(descr:string);
Begin
    //A plugin ler informciit lehet belltani

    sendInfo('instanceDescription',descr);
End;

procedure TPlugin.addtolog(event:string);
Begin
    //Napl bejegyzs kirsa

    sendInfo('PluginEvent',event);
End;



end.

